package SrvMngr::Controller::Shares;
#
# Generated by SM2Gen version:0.9(20Jan2025) Chameleon version:4.5.4 On Python:3.12.3 at 2025-05-21 08:46:42 
# Remember that each route must be unique (else they just overwrite each other).
# you cannot have get and post on the same name and url.
#
#----------------------------------------------------------------------
# heading     : Network
# description : Shared Folders
# navigation  : 7000 400
#
# name : shares,    method : get,   url : /shares,   ctlact : Shares#main
# name : sharesu,   method : post,  url : /sharesu,  ctlact : Shares#do_update
# name : sharesd,   method : get,   url : /sharesd,  ctlact : Shares#do_display
#
# routes : end
#
# Documentation: https://wiki.contribs.org/Shares
#----------------------------------------------------------------------

#
# Scheme of things:
#
# TBA!!

use strict;
use warnings;
use Mojo::Base 'Mojolicious::Controller';

use constant FALSE => 0;
use constant TRUE  => 1;

use Locale::gettext;
use SrvMngr::I18N;
use SrvMngr qw(theme_list init_session);

use Data::Dumper;

use esmith::util;
use esmith::util::network;
use esmith::ConfigDB;
use esmith::AccountsDB;
use esmith::NetworksDB;
use esmith::HostsDB;
use esmith::DomainsDB;

my $cdb;
my $adb;
my $ndb; 
my $hdb; 
my $ddb; 

my %sf_data;

require '/usr/share/smanager/lib/SrvMngr/Controller/Shares-Custom.pm';  #The code that is to be added by the developer

sub main {
#
# Initial entry - route is "/<whatever>"
#
#set initial panel
#for initial panel:
	#Specifiy panel to enter
	#load up _data hash with DB fields
	#load up stash with pointer(s) to control fields hash(= get-))
		#and a pointer to the prefix_data hash
#render initial panel

    my $c = shift;
    $c->app->log->info( $c->log_req );

	#The most common ones
	 $cdb = esmith::ConfigDB->open()   || die("Couldn't open config db");
	 $adb = esmith::AccountsDB->open() || die("Couldn't open Accounts db");
	 $ndb = esmith::NetworksDB->open() || die("Couldn't open Network db");
	 $hdb = esmith::HostsDB->open() 	  || die("Couldn't open Hosts db");
	 $ddb = esmith::DomainsDB->open()  || die("Couldn't open Domains db");

     %sf_data = ();
    my $title = $c->l('sf_Shared_Folders');
    my $modul = '';

    $sf_data{'trt'} = 'LIST';
    
    #Load any DB entries into the <prefix>_data area so as they are preset in the form
    # which DB - this only really works if the initial panel is a PARAMS type panel and not a TABLE
    my $db = $cdb; #pickup local or global db or Default to config
    
	
	$c->do_display($sf_data{'trt'});
	
}

# Post request with params - submit from the form 
sub do_update {
#
# Return after submit pushed on panel (this is a post) - route is "/<whatever>u"
# parameters in the params hash.
#
#load up all params into prefix_data hash:
#By panel (series of if statements - only one executed):
		#call validate-PANEL() - return ret = ok or error message
			
#if validation not ok:
	#render back to current panel with error message in stash
#otherwise:
	#By panel (series of if statements - only one executed):
		#do whatever is required: call perform-PANEL() - return "ok" or Error Message
			#call signal-event for any global actions specified (check it exists - error and continue?)
			#if action smeserver-<whatever>-update exists
				#signal_event smeserver-<whatever>-update
			#call signal-event for any specific actions for thids panel (check it exists first - error and continue)
		#set success in stash
		#if no "nextpanel" entry:
			#set firstpanel
		#else 
			#set nextpanel
		#call render
	
    my $c = shift;
    $c->app->log->info($c->log_req);
	my $modul = '';

	#The most common ones - you might want to comment out any not used.
	$cdb = esmith::ConfigDB->open()   || die("Couldn't open config db");
	$adb = esmith::AccountsDB->open() || die("Couldn't open Accounts db");
	$ndb = esmith::NetworksDB->open() || die("Couldn't open Network db");
	$hdb = esmith::HostsDB->open() 	  || die("Couldn't open Hosts db");
	$ddb = esmith::DomainsDB->open()  || die("Couldn't open Domains db");

    my $title = $c->l('sf_Shared_Folders');

	# Accessing all POST/GET parameters
    my $params = $c->req->params->to_hash;

    # Get number of POST parameters
    #my $num_params = keys scaler %$params;
    
    #Params are available in the hash "params" - copy to the prefix_data hash
    #while (my ($key, $value) = each %{$c->req->params->to_hash}) {
    #    $sf_data{$key} = $value;
    #}

    # the value of trt will tell you which panel has returned    
    my $trt = $c->param('trt') || 'LIST'; #hidden control on every form.
    my $ret = 'ok';

    #Validate the parameters in a custom sub one for each panel (although only one of these will be executed)
    my $thispanel;
    
		if ($trt eq 'LIST'){
			#Validate form parameters for panel LIST
			$ret = $c->validate_LIST(\%sf_data);
			$thispanel = 'LIST';
		}
	
		if ($trt eq 'MODIFY'){
			#Validate form parameters for panel MODIFY
			$ret = $c->validate_MODIFY(\%sf_data);
			$thispanel = 'MODIFY';
		}
	
		if ($trt eq 'PERMISSIONS'){
			#Validate form parameters for panel PERMISSIONS
			$ret = $c->validate_PERMISSIONS(\%sf_data);
			$thispanel = 'PERMISSIONS';
		}
	
		if ($trt eq 'REMOVE'){
			#Validate form parameters for panel REMOVE
			$ret = $c->validate_REMOVE(\%sf_data);
			$thispanel = 'REMOVE';
		}
	
	if ($ret ne "ok"){
		$c->stash(error => $c->l($ret));
		$c->do_display($thispanel);
	} else {
		#Do whatever is needed, including writing values to the DB
		
		
			if ($trt eq 'LIST'){
				#do whatever is required ...
				$ret = $c->perform_LIST(\%sf_data);
				if ($ret ne "ok") {
					# return to the panel with error message
					$c->stash(error => $c->l($ret));
					$c->stash( 
						title => $title, 
						modul => $modul,
						sf_data  => \%sf_data
					);
					$c->render(template => "shares");	
				} else {
					$c->stash( success => $c->l('sf_LIST_panel_action_was_successful')); #A bit bland - edit it in the lex file
				}
			}
		
			if ($trt eq 'MODIFY'){
				#do whatever is required ...
				$ret = $c->perform_MODIFY(\%sf_data);
				if ($ret ne "ok") {
					# return to the panel with error message
					$c->stash(error => $c->l($ret));
					$c->stash( 
						title => $title, 
						modul => $modul,
						sf_data  => \%sf_data
					);
					$c->render(template => "shares");	
				} else {
					$c->stash( success => $c->l('sf_MODIFY_panel_action_was_successful')); #A bit bland - edit it in the lex file
				}
			}
		
			if ($trt eq 'PERMISSIONS'){
				#do whatever is required ...
				$ret = $c->perform_PERMISSIONS(\%sf_data);
				if ($ret ne "ok") {
					# return to the panel with error message
					$c->stash(error => $c->l($ret));
					$c->stash( 
						title => $title, 
						modul => $modul,
						sf_data  => \%sf_data
					);
					$c->render(template => "shares");	
				} else {
					$c->stash( success => $c->l('sf_PERMISSIONS_panel_action_was_successful')); #A bit bland - edit it in the lex file
				}
			}
		
			if ($trt eq 'REMOVE'){
				#do whatever is required ...
				$ret = $c->perform_REMOVE(\%sf_data);
				if ($ret ne "ok") {
					# return to the panel with error message
					$c->stash(error => $c->l($ret));
					$c->stash( 
						title => $title, 
						modul => $modul,
						sf_data  => \%sf_data
					);
					$c->render(template => "shares");	
				} else {
					$c->stash( success => $c->l('sf_REMOVE_panel_action_was_successful')); #A bit bland - edit it in the lex file
				}
			}
		
		# and call any signal-events needed
		#TBD
		# Setup shared data and call panel
		if ('none' eq 'none') {
			$sf_data{'trt'} = 'LIST';
		} else {
			$sf_data{'trt'} = 'none';
		}	
		$c->do_display($sf_data{'trt'});
	} 
}

sub do_display {
#
# Return after link clicked in table (this is a get) - route is "/<whatever>d"
# Expects ?trt=PANEL&selected="TableRowName" plus any other required
#
# OR it maybe a post from the main panel to add a new record 
#
#load up all supplied params into prefix_data hash
#call get-selected-PANEL() - returns hash of all relevent parameters
#load up returned hash into prefix_data
#render - to called panel

    my ($c,$trt) = @_;
    $c->app->log->info($c->log_req);

	#The most common ones - you might want to comment out any not used.
	$cdb = esmith::ConfigDB->open()   || die("Couldn't open config db");
	$adb = esmith::AccountsDB->open() || die("Couldn't open Accounts db");
	$ndb = esmith::NetworksDB->open() || die("Couldn't open Network db");
	$hdb = esmith::HostsDB->open() 	  || die("Couldn't open Hosts db");
	$ddb = esmith::DomainsDB->open()  || die("Couldn't open Domains db");
    
    my $title = $c->l('sf_Shared_Folders');
    my $modul = "";

	# Accessing all parameters
    my $params = $c->req->params->to_hash;

    # Get number of parameters
    my $num_params = keys %$params;
    
    #Tag as Post or Get (ie. create new entry or edit existing one
    my $is_new_record = ($c->req->method() eq 'POST');
    
    #Params are available in the hash "params" - copy to the prefix_data hash
    #while (my ($key, $value) = each %{$c->req->params->to_hash}) {
    #    $sf_data{$key} = $value;
    #}

    # the value of trt will tell you which panel has returned   
    if (! $trt){ 
		$trt = $c->param('trt') || 'LIST'; #Indicates where to go now
	}
 
    # Now add in the params from the selected row from the table
		
    my %selectedrow;
    
		if ($trt eq 'LIST'){
			#Validate Get selected row (if applicable)  LIST
				%selectedrow = $c->get_selected_LIST($sf_data{'Selected'},$is_new_record);
		}
	
		if ($trt eq 'MODIFY'){
			#Validate Get selected row (if applicable)  MODIFY
				%selectedrow = $c->get_selected_MODIFY($sf_data{'Selected'},$is_new_record);
		}
	
		if ($trt eq 'PERMISSIONS'){
			#Validate Get selected row (if applicable)  PERMISSIONS
				%selectedrow = $c->get_selected_PERMISSIONS($sf_data{'Selected'},$is_new_record);
		}
	
		if ($trt eq 'REMOVE'){
			#Validate Get selected row (if applicable)  REMOVE
				%selectedrow = $c->get_selected_REMOVE($sf_data{'Selected'},$is_new_record);
		}
	
 
	#Copy in the selected row params to the prefix_data hash to pass to the panel
	while (my ($key, $value) = each %selectedrow){
        $sf_data{$key} = $value;
    }
	# Where to go now
	$sf_data{'trt'} = $trt;
	
	# Set up other shared data according to the panel to go to
    
		if ($trt eq 'LIST'){
			# pickup any other contents needed and load them into hash shared with panel
			my %returned_hash;
			# subroutine returns a hash directly
			%returned_hash = $c->get_data_for_panel_LIST();
			# Copy each key-value pair from the returned hash to the prefix data hash
			while (my ($key, $value) = each %returned_hash) {
				$sf_data{$key} = $value;
			}
		}
	
		if ($trt eq 'MODIFY'){
			# pickup any other contents needed and load them into hash shared with panel
			my %returned_hash;
			# subroutine returns a hash directly
			%returned_hash = $c->get_data_for_panel_MODIFY();
			# Copy each key-value pair from the returned hash to the prefix data hash
			while (my ($key, $value) = each %returned_hash) {
				$sf_data{$key} = $value;
			}
		}
	
		if ($trt eq 'PERMISSIONS'){
			# pickup any other contents needed and load them into hash shared with panel
			my %returned_hash;
			# subroutine returns a hash directly
			%returned_hash = $c->get_data_for_panel_PERMISSIONS();
			# Copy each key-value pair from the returned hash to the prefix data hash
			while (my ($key, $value) = each %returned_hash) {
				$sf_data{$key} = $value;
			}
		}
	
		if ($trt eq 'REMOVE'){
			# pickup any other contents needed and load them into hash shared with panel
			my %returned_hash;
			# subroutine returns a hash directly
			%returned_hash = $c->get_data_for_panel_REMOVE();
			# Copy each key-value pair from the returned hash to the prefix data hash
			while (my ($key, $value) = each %returned_hash) {
				$sf_data{$key} = $value;
			}
		}
	
	
	# and table control fields
     $c->stash(Table1=>$c->get_Table1());
     $c->stash(Table2=>$c->get_Table2());
     $c->stash(Table3=>$c->get_Table3());

	
	# Data for panel
	$c->stash( 
		title 			=> $title, 
		modul => $modul,
		sf_data  => \%sf_data
	);
	$c->render(template => "shares");
}    
1;